// /////////////////////////////////////////////////////
// Effektiv C++
// Tip 1: Vermeidung von Problemen des Prprozessors
//
// Code: Stephan Brumme, 15.Mai 2002
//
// Zweck: - Definition des Default-Wertes in CComplex als
//          Konstante
//        - inline-Funktion als Template umgesetzt
//        - (Vergleichs-Operator in CComplex eingefhrt)


#include "Complex.h"
#include <iostream>
using namespace std;


// generischer Vergleich als Template
template<class T>
inline const bool Equal(T a, T b)
{
	 return a == b;
}


void main()
{
	///////////////////////////////////////////
	// Template fr 2 Integers
	cout << "Integer: 2 == 4: " << Equal(2, 4) << endl;
	cout << "Integer: 4 == 4: " << Equal(4, 4) << endl;

	// Template fr die komplexen Zahlen
	CComplex a;			// a = (0,0)
	CComplex b(3,7);	// c = b = (3,7)
	CComplex c=b;
	cout << "Complex: (0,0) == (3,7): " << Equal(a,b) << endl;
	cout << "Complex: (3,7) == (3,7): " << Equal(b,c) << endl;
}