// /////////////////////////////////////////////////////
// Effektiv C++
// Tip 10: Copy-Konstruktor und Zuweisungsoperator
//         in Klassenhierarchien
//
// Code: Stephan Brumme, 16.Mai 2002
//
// Zweck: - Aufruf der Basisklasse im Copy-Konstruktor/Zuweisungsoeprator nicht vergessen
//          (beide sind zu Beginn auskommentiert)


// fr I/O
#include <iostream>
using namespace std;


// Basisklasse
class CBase
{
public:
	// Konstruktor
	CBase(int nNumber = 0) : m_nNumber(nNumber) {}
	// zeige Attribute an
	void Show() const
	{
		cout << "m_nNumber: " << m_nNumber << endl;
	}

private:
	int m_nNumber;
};


// abgeleitete Klasse
class CDerived : public CBase
{
public:
	// Konstruktor
	CDerived(int nNumber, char cChar) : CBase(nNumber), m_cChar(cChar) {}
	// Copy-Konstruktor
	CDerived(const CDerived& obj) : /*CBase(obj),*/ m_cChar(obj.m_cChar) {}
	// Zuweisungsoperator
	CDerived& operator=(const CDerived& obj)
	{
		//CBase::operator=(obj);
		m_cChar = obj.m_cChar;
		return *this;
	}

	// zeige Attribute an
	void Show() const
	{
		CBase::Show();
		cout << "m_cChar: " << m_cChar << endl;
	}

private:
	char m_cChar;
};



void main()
{
	// Erzeugung zweier Objekte
	CBase    a;
	CDerived b(42, 'A');

	// Anzeige der Attribute
	cout << "a: ";
	a.Show();
	cout << "b: ";
	b.Show();

	// Nutzung des Copy-Konstruktors
	CDerived c = b;
	cout << "c: ";
	c.Show();

	// Zuweisungsoperator
	CDerived d(7,'B');
	d = b;
	cout << "d: ";
	d.Show();
}