// /////////////////////////////////////////////////////
// Effektiv C++
//
// Komplexe Zahlen
// Version: 2
// Code: Stephan Brumme, 14.Mai 2002
//

#include "Complex.h"

#include <iostream>
using namespace std;


const double CComplex::DEFAULTVALUE = 0.0;


// Default-Konstruktor
CComplex::CComplex(double dReal, double dImg)
         : m_dReal(dReal), m_dImg(dImg)
{
}


// Copy-Konstruktor
CComplex::CComplex(const CComplex& obj)
         : m_dReal(obj.m_dReal), m_dImg(obj.m_dImg)
{
	cerr << "Copy! ";
}


// Destruktor
CComplex::~CComplex()
{
	// leer ...
}


// Zuweisungs-Operator, endgltige Version
/*CComplex& CComplex::operator=(const CComplex& obj)
{
	// Attribute kopieren
	m_dReal = obj.m_dReal;
	m_dImg  = obj.m_dImg;
	
	return *this;
}*/


// Zuweisungs-Operator, Variante I
/*void CComplex::operator=(const CComplex& obj)
{
	// Attribute kopieren
	m_dReal = obj.m_dReal;
	m_dImg  = obj.m_dImg;
}*/


// Zuweisungs-Operator, Variante II
/*CComplex CComplex::operator=(const CComplex& obj)
{
	// Attribute kopieren
	m_dReal = obj.m_dReal;
	m_dImg  = obj.m_dImg;
	
	return *this;
}*/


// Zuweisungs-Operator, Variante III
const CComplex& CComplex::operator=(const CComplex& obj)
{
	// Attribute kopieren
	m_dReal = obj.m_dReal;
	m_dImg  = obj.m_dImg;
	
	return *this;
}


// Vergleichsoperator
bool CComplex::operator==(const CComplex& obj) const
{
	return (m_dReal == obj.m_dReal) && (m_dImg == obj.m_dImg);
}


// Attribute ausgeben
void CComplex::Show() const
{
	cout << "(" << m_dReal << "," << m_dImg << ")";
}