// /////////////////////////////////////////////////////
// Effektiv C++
// Tip 12: Prfung auf Zuweisung an sich selbst
//
// Code: Stephan Brumme, 16.Mai 2002
//
// Zweck: - wie Tip 6, nur im Zuweisungsoperator auf
//          Objektidentitt prfen
//        - m_strString ist nur dann "World", wenn Prfung fehlt
//          (ist auch am Anfang auskommentiert)


// fr I/O
#include <iostream>
using namespace std;


// Klasse entspricht weitgehend dem Tip 6
class CDynamic
{
public:
	// Default-Konstruktor
	CDynamic()
	{
		// Speicher alloziieren
		m_strString = new char[strlen(m_strHello)+1];
		// und Zeichenkette kopieren
		strcpy(m_strString, m_strHello);
	}

	// Copy-Konstruktor
	CDynamic(const CDynamic& obj)
	{
		// Speicher alloziieren
		m_strString = new char[strlen(obj.m_strString)+1];
		// und Zeichenkette kopieren
		strcpy(m_strString, obj.m_strString);
	}

	// Zuweisungsoperator
	CDynamic& operator=(const CDynamic& obj)
	{
		// neuer Code aus Tip 12:
		if (this == &obj)
			return *this;

		delete[] m_strString;
		// Speicher alloziieren
		m_strString = new char[strlen(obj.m_strString)+1];
		// und Zeichenkette kopieren
		strcpy(m_strString, obj.m_strString);

		return *this;
	}

	// Destruktor
	~CDynamic()
	{
		// alte Zeichenkette berschreiben
		strcpy(m_strString, m_strWorld);
		// Speicher freigeben 
		delete[] m_strString;
	}


	char* m_strString;
	static const char* m_strHello;
	static const char* m_strWorld;
};


const char* CDynamic::m_strHello = "Hello";
const char* CDynamic::m_strWorld = "World";



void main()
{
	CDynamic a;
	// "Hello"
	cout << a.m_strString << endl;

	a = a;

	// Fehler, wenn Copy-Konstruktor oder Zuweisungsoperator fehlt
	cout << a.m_strString << endl;
}