// /////////////////////////////////////////////////////
// Effektiv C++
//
// Komplexe Zahlen
// Version: 4
// Code: Stephan Brumme, 14.Mai 2002
//

#include <math.h>


class CComplex
{
	// Standardwert fr Konstruktor
	static const double DEFAULTVALUE;

public:
	// Default-Konstruktor:
	// kann auch ohne Parameter aufgerufen werden, da Default-Wert vorhanden
	CComplex(double dReal = DEFAULTVALUE, double dImg = DEFAULTVALUE);

	// leerer Destruktor
	~CComplex() {}

	// Vergleichsoperator
	bool operator==(const CComplex& obj) const;

	// Schreibzugriff
	inline void SetReal(double dReal) { m_dReal = dReal; }
	inline void SetImg (double dImg)  { m_dImg  = dImg; }
	// Lesezugriff auf Attribute
	inline double GetReal() const { return m_dReal; }
	inline double GetImg () const { return m_dImg; }
	inline double GetModulus() const { return m_dModulus; }
	//                               { return sqrt(m_dReal*m_dReal + m_dImg*m_dImg); }

//private:
	double m_dReal;
	double m_dImg;
	double m_dModulus;
};
