// /////////////////////////////////////////////////////
// Effektiv C++
// Tip 14: Vermeidung von Attributen in der ffentlichen Schnittstelle
//
// Code: Stephan Brumme, 16.Mai 2002
//
// Zweck: - Verlust der Kontrolle bei ffentlichen Attributen
//        - "private" in Complex.h wieder aktiveren
//        - Zuweisung vom Betrag (modulus) durch Berechnung ersetzen
//          (ebenfalls in Complex.h)


#include "Complex.h"
#include <iostream>
using namespace std;


void main()
{
	CComplex a;			// a = (0,0)
	CComplex b(3,7);	// b = (3,7)

	cout << "a = (" << a.GetReal() << "," << a.GetImg() << ")" << endl;
	cout << "b = (" << b.GetReal() << "," << b.GetImg() << ")" << endl;

	// Real-Anteil von a ndern
	a.SetReal(-1);
	cout << "a = (" << a.GetReal() << "," << a.GetImg() << ")" << endl;

	// Imaginr-Anteil von b ndern
	b.SetImg(500);
	cout << "b = (" << b.GetReal() << "," << b.GetImg() << ")" << endl;

	// Betrag manipulieren (wenn public)
	cout << "Betrag von a: " << a.GetModulus() << endl;
	a.m_dModulus = -1.0;
	cout << "Betrag von a: " << a.GetModulus() << endl;
}