// /////////////////////////////////////////////////////
// Effektiv C++
// Tip 15: Elementfunktionen, globale Funktionen und
//         friend-Funktionen
//
// Code: Stephan Brumme, 16.Mai 2002
//
// Zweck: - Set/Get-Methoden sind Elementfunktionen
//        - Addition muss global sein, um implizite Konvertierung zu erlauben
//        - Addition ist auch friend, da Zugriff auf private-Attribute erforderlich


#include "Complex.h"
#include <iostream>
using namespace std;


void main()
{
	CComplex a(42/*,0*/);	// a = (42,0)

	// okay, da 42 nach CComplex konvertiert werden kann
	cout << "Elementfunktion: (a==(42,0)) = " << (a==42) << endl;
	// Fehler, da 42 kein Objekt ist und deshalb == nicht aufgelst werden kann
	//cout << "Elementfunktion: ((42,0)==a) = " << (42==a) << endl;

	CComplex b;
	// okay, da 7 nach CComplex(7,0) konvertiert werden kann
	b = a + 7;
	cout << "globale Funktion: a + (7,0) = (" << b.GetReal() << "," << b.GetImg() << ")" << endl;
	// auch okay, da 7 ber globale Funktion nach CComplex(7,0) konvertiert werden kann
	b = 7 + a;
	cout << "globale Funktion: (7,0) + a = (" << b.GetReal() << "," << b.GetImg() << ")" << endl;
}