// /////////////////////////////////////////////////////
// Effektiv C++
// Tip 16: Mglichst hufige Benutzung von const
//
// Code: Stephan Brumme, 16.Mai 2002
//
// Zweck: - mglichst viele Methoden als const festlegen
//        - m_nAccesses in CComplex ist mutable, d.h. immer vernderbar
//        - Demonstration verschiedener const's bei Zeigern


#include "Complex.h"
#include <iostream>
using namespace std;


void main()
{
	CComplex a(42,0);

	// erlaubt, wenn operator+ nicht const zurckliefert
	//(a + 7) = 5;

	cout << "Zugriffe: " << a.GetAccesses()<< endl;
	cout << "a = (" << a.GetReal() << "," << a.GetImg() << ")" << endl;
	cout << "Zugriffe: " << a.GetAccesses()<< endl;

	///////////////////////////////////////////
	// Verhalten von "const OBJECT* variable"
	const CComplex* p42_0 = new CComplex(42,0);
	// Fehler, da Inhalt const ist
	// *p42_0 = a;
	// okay, da nicht der Inhalt gendert wird !
	// p42_0 = new CComplex(43,1);

	///////////////////////////////////////////
	// Verhalten von "OBJECT* const variable"
	CComplex* const p23_0 = new CComplex(23,0);
	// okay, da nicht der Zeiger gendert wird !
	*p23_0 = a;
	// Fehler, da Zeiger const ist
	// p23_0 = new CComplex(24,1);

	///////////////////////////////////////////
	// Verhalten von "const OBJECT* const variable"
	const CComplex* const p7_0 = new CComplex(7,0);
	// Fehler, da Inhalt const ist
	// *p7_0 = a;
	// Fehler, da Zeiger const ist
	// p23_0 = new CComplex(24,1);

}