// /////////////////////////////////////////////////////
// Effektiv C++
// Tip 17: bergabe via Wert vs. bergabe via Referenz
//
// Code: Stephan Brumme, 16.Mai 2002
//
// Zweck: - Typkonvertierung bei Wertparameter zeigen
//          (tritt bei Referenzbergabe nicht auf)
//        - Parameter von CallShow entkommentieren


// fr I/O
#include <iostream>
using namespace std;


// Basisklasse
class CBase
{
public:
	virtual void Show() const
	{
		cout << "CBase" << endl;
	}
};


// abgeleitete Klasse
class CDerived : public CBase
{
public:
	void Show() const 
	{
		cout << "CDerived" << endl;
	}
};


// Show-Methode aufrufen
void CallShow(/*const*/ CBase/*&*/ obj)
{
	obj.Show();
}



void main()
{
	// ein Objekt der abgeleiteten Klasse
	CDerived derived;
	// Show aufrufen lassen
	CallShow(derived);
}