// /////////////////////////////////////////////////////
// Effektiv C++
//
// Komplexe Zahlen
// Version: 4
// Code: Stephan Brumme, 14.Mai 2002
//

#include <math.h>


class CComplex
{
	// Standardwert fr Konstruktor
	static const double DEFAULTVALUE;

public:
	// Default-Konstruktor
	CComplex();
	CComplex(double dReal);
	CComplex(double dReal, double dImg);
	// kann auch ohne Parameter aufgerufen werden, da Default-Wert vorhanden
	//CComplex(double dReal = DEFAULTVALUE, double dImg = DEFAULTVALUE);

	// leerer Destruktor
	~CComplex() {}

	// Vergleichsoperator
	bool operator==(const CComplex& obj) const;

	// Schreibzugriff
	inline void SetReal(double dReal) { m_dReal = dReal; }
	inline void SetImg (double dImg)  { m_dImg  = dImg; }
	// Lesezugriff auf Attribute
	inline double GetReal() const { m_nAccesses++; return m_dReal; }
	inline double GetImg () const { m_nAccesses++; return m_dImg; }
	inline double GetModulus() const { m_nAccesses++; return sqrt(m_dReal*m_dReal + m_dImg*m_dImg); }
	inline int    GetAccesses() const { return m_nAccesses; }

	// Addition mit impliziter Konvertierung erlauben
	friend const CComplex operator+(const CComplex& a, const CComplex& b);

private:
	double m_dReal;
	double m_dImg;

	// darf immer gendert werden
	mutable int m_nAccesses;
};



// friend-Funktion muss noch deklariert werden
const CComplex operator+(const CComplex& a, const CComplex& b);