// /////////////////////////////////////////////////////
// Effektiv C++
// Tip 20: Quellen von Mehrdeutigkeiten
//
// Code: Stephan Brumme, 16.Mai 2002
//
// Zweck: - Mehrdeutigkeiten zeigen
//        - Compiler kann nicht zwischen Konstruktor und Konvertierung whlen


#include <iostream>
using namespace std;


// forward-Deklaration
class CChild;


// ein Erwachsener
class CAdult
{
public:
	// und im Herzen trotzdem Kind bleiben
	CAdult(const CChild& obj)
	{
		cout << "CAdult Konstruktor mit CChild" << endl;
	}

	// etwas sagen
	void SayHello() const
	{
		cout << "Hallo, ich bin schon erwachsen !" << endl;
	}
};


// ein Kind
class CChild
{
public:
	// erwachsen werden ...
	operator CAdult() const
	{
		cout << "CChild.operator CAdult" << endl;
	}

	// etwas sagen
	void SayHello() const
	{
		cout << "Schade, ich bin immer noch ein Kind ..." << endl;
	}
};


// etwas sagen
void Talk(const CAdult& obj)
{
	obj.SayHello();
}


void main()
{
	CChild c;

	// Fehler, nicht klar, ob CAdult(c) oder c.operator Adult() aufgerufen werden soll
	//Talk(c);
}