// /////////////////////////////////////////////////////
// Effektiv C++
// Tip 22: Unterteilung des globalen Namensraumes
//
// Code: Stephan Brumme, 16.Mai 2002
//
// Zweck: - Namenskollisionen durch Namespaces verhindern


// fr I/O
#include <iostream>
using namespace std;


// ein einfaches Auto
namespace Car
{
	const int VERSION = 2;
	void Drive()
	{
		cout << "Zzzzzzzzzzzsch !" << endl;
	}
}


// und ein Fahrrad
namespace Bike
{
	const int VERSION = 7;
	void Drive()
	{
		cout << "Aechz !" << endl;
	}
}



void main()
{
	// beide Vehikel sollen fahren
	Car::Drive();
	Bike::Drive();

	// Namensraum Car ffnen
	using namespace Car;
	Drive();
	cout << "Version " << VERSION << endl;

	using namespace Bike;
	// Fehler, mehrdeutig !
	//Drive();
}