// /////////////////////////////////////////////////////
// Effektiv C++
// Tip 6: Initialisierung vs. Zuweisung im Konstruktor
//
// Code: Stephan Brumme, 15.Mai 2002
//
// Zweck: - Zuweisung im Konstruktor von CClass durch
//          Initialisierung ersetzen
//        - CSimple zeigt an, welche Konstruktoren/Operatoren benutzt werden


#include <iostream>
using namespace std;


// fast leere Hilfs-Klasse
class CSimple
{
public:
	CSimple()
	{
		cout << "Default-Konstruktor von CSimple" << endl;
	}

	CSimple(const CSimple& obj) 
	{
		cout << "Copy-Konstruktor von CSimple" << endl;
	}
	CSimple& operator=(const CSimple& obj) 
	{
		cout << "Zuweisungsoperator von CSimple" << endl;

		return *this;
	}
};


// Initialisierung im Konstruktor
class CClass
{
public:
	CClass(int nNumber, char cChar, const CSimple& obj)
		: m_nNumber(nNumber), m_cChar(cChar)//, m_Simple(obj)
	{
		m_Simple = obj;
	}

private:
	const int m_nNumber;
	char&     m_cChar;
	CSimple   m_Simple;
};



void main()
{
	int  nNumber = 42;
	char cChar   = 'A';
	// Achtung: ruft Defaultkonstruktor auf:
	// 1.Zeile der Bildschirmausgabe ignorieren !
	CSimple simple;

	// einmal CClass instanziieren
	CClass myClass(nNumber, cChar, simple);
}